function conversion()
	for i,v in ipairs(features) do
		local words = v[1]
		
		local operator = words[2]
		
		if (operator == "is") then
			local output = {}
			local name = words[1]
			local thing = words[3]
			
			local mat1 = 0
					
			if (name ~= "text") and (name ~= "level") then
				mat1 = 1
			end
			
			if (mat1 == 1) and (getmat(thing) ~= nil) then
				if (featureindex[name] ~= nil) then
					for a,b in ipairs(featureindex[name]) do
						local rule = b[1]
						local conds = b[2]
						local target,verb,object = rule[1],rule[2],rule[3]

						if (target == name) and (verb == "is") and (object ~= name) then
							if (object ~= "text") then
								for d,mat in pairs(objectlist) do
									if (name ~= object) and (d ~= "group") then
										if (d == object) then
											table.insert(output, {object, conds})
										elseif (object == "not " .. d) then
											table.insert(output, {"error", conds})
										end
									end
								end
							else
								if (name ~= object) then
									table.insert(output, {object, conds})
								end
							end
						end
					end
				end
				
				if (#output > 0) then
					local conversions = {}
					
					for k,v3 in ipairs(output) do
						local object = v3[1]
						local conds = v3[2]
						
						if (object ~= "all") and (object ~= "text") and (object ~= "group") then
							table.insert(conversions, v3)
						elseif (object == "all") then
							addaction(0,{"createall",{name,conds}})
							--createall({name,conds})
						elseif (object == "text") then
							table.insert(conversions, {"text_" .. name,conds})
						end
					end
					
					if (#conversions > 0) then
						if (name ~= "text") then
							convert(name,conversions)
						else
							local convertthese = {}
							for a,b in ipairs(units) do
								if (b.strings[UNITTYPE] == "text") then
									table.insert(convertthese, b.strings[UNITNAME])
								end
							end
							
							if (#convertthese > 0) then
								for a,b in ipairs(convertthese) do
									convert(b,conversions)
								end
							end
						end
					end
				end
			end
		end
	end
end

function convert(stuff,mats)
	local layer = map[0]
	local delthese = {}
	local mat1 = stuff
	
	if (mat1 ~= "empty") and (mat1 ~= "level") then
		if (unitlists[mat1] ~= nil) then
			for i,unitid in ipairs(unitlists[mat1]) do
				local unit = mmf.newObject(unitid)
				local x,y,dir,id,name = unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[ID],unit.strings[UNITNAME]
				
				if (unit.flags[CONVERTED] == false) then
					addaction(unit.fixed,{"convert",mats})
					unit.flags[CONVERTED] = true
				end
			end
		end
	elseif (mat1 == "empty") then
		addaction(unitid,{"emptyconvert",mats})
	elseif (mat1 == "level") then
		local levelmats = ""
		
		for i,matdata in ipairs(mats) do
			if (matdata[2] == nil) then
				levelmats = levelmats .. matdata[1] .. ","
			end
		end

		if (levelmats ~= "") then
			MF_levelconversion(levelmats)
		end
	end
	
	--[[
	if (#delthese > 0) then
		for i,unitid in ipairs(delthese) do
			local unit = mmf.newObject(unitid)
			addundo({"remove",unit.strings[UNITNAME],unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[ID]})
			delunit(unitid)
			MF_specialremove(unitid,0,2)
		end
	end
	]]--
end

function doconvert(data)
	local style = data[2]
	local mats = data[3]
	
	local unitid = data[1]
	local unit = mmf.newObject(unitid)
	local x,y,dir,name,id = unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.strings[UNITNAME],unit.values[ID]
	
	if (style == "convert") then
		local delthis = false
		
		for a,matdata in ipairs(mats) do
			local mat2 = matdata[1]
			local conds = matdata[2]
			
			if (mat2 ~= "empty") then
				if testcond(conds,unit.fixed) then
					local ingameid = 0
					if (a == 1) then
						ingameid = id
					elseif (a > 1) then
						ingameid = newid()
					end
					
					MF_alert(tostring(id) .. " unit, " .. tostring(data[1]) .. ", name: " .. name .. ", result: " .. tostring(ingameid))
		
					local newunitid = MF_emptycreate(mat2,x,y)
					local newunit = mmf.newObject(newunitid)
					
					newunit.values[ONLINE] = 1
					newunit.values[XPOS] = x
					newunit.values[YPOS] = y
					newunit.values[DIR] = dir
					
					newunit.values[ID] = ingameid
					
					newunit.values[EFFECT] = 1
					newunit.flags[9] = true
					newunit.flags[CONVERTED] = true
					
					addunit(newunitid)
					addunitmap(newunitid,x,y)
					dynamic(newunitid)
		
					addundo({"create",newunit.strings[UNITNAME],ingameid})
		
					if (newunit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
					
					delthis = true
				end
			else
				if testcond(conds,unit.fixed) then
					updateunitmap(unitid,x,y,x,y)
					delthis = true
				end
			end
		end
		
		if delthis then
			addundo({"remove",unit.strings[UNITNAME],unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[ID]})
			delunit(unitid)
			dynamic(unitid)
			MF_specialremove(unitid,0,2)
		end
	elseif (style == "emptyconvert") then
		for a,matdata in ipairs(mats) do
			local mat2 = matdata[1]
			local conds = matdata[2]

			if (mat2 ~= "empty") then
				local convunitmap = {}
				
				for a,unit in ipairs(units) do
					local tileid = unit.values[XPOS] + unit.values[YPOS] * roomsize
					convunitmap[tileid] = 1
				end
				
				for i=0,roomsize-1 do
					for j=0,roomsize-1 do
						local empty = 1
						
						local tileid = i + j * roomsize
						if (convunitmap[tileid] ~= nil) then
							empty = 0
						end
						
						if (layer:get_x(i,j) ~= 255) then
							empty = 0
						end
						
						if (empty == 1) and testcond(conds,2,i,j) then	
							local newunitid = MF_emptycreate(mat2,i,j)
							local newunit = mmf.newObject(newunitid)
							
							local id = newid()
							local dir = math.random(0,3)
							
							newunit.values[ONLINE] = 1
							newunit.values[XPOS] = i
							newunit.values[YPOS] = j
							newunit.values[DIR] = dir
							newunit.values[ID] = id
							newunit.values[EFFECT] = 1
							newunit.flags[9] = true
							newunit.flags[CONVERTED] = true
							
							addunit(newunitid)
							addunitmap(newunitid,i,j)
							dynamic(newunitid)
							
							addundo({"create",newunit.strings[UNITNAME],id})
							
							if (newunit.strings[UNITTYPE] == "text") then
								updatecode = 1
							end
						end
					end
				end
			end
		end
	end
end