function code()
	if (updatecode == 1) then
		features = {}
		featureindex = {}
		visualfeatures = {}
		local firstwords = {}
		local alreadyused = {}
		
		--[[
		featureindex["level"] = {}
		featureindex["stop"] = {}
		
		local ls_rule = {"level","is","stop"}
		local ls_ids = {}
		local ls_conds = {}
		
		table.insert(features, {ls_rule,ls_conds,ls_ids})
		table.insert(featureindex["level"], {ls_rule,ls_conds,ls_ids})
		table.insert(featureindex["stop"], {ls_rule,ls_conds,ls_ids})
		]]--
	
		if (#codeunits > 0) then
			for iid,unitid in ipairs(codeunits) do
				local unit = mmf.newObject(unitid)
				local x,y = unit.values[XPOS],unit.values[YPOS]
				local ox,oy,nox,noy = 0,0
				local tileid = x + y * roomsize

				setcolour(unit.fixed)
				
				if (alreadyused[tileid] == nil) then
					for i=1,2 do
						local drs = dirs[i+2]
						local ndrs = dirs[i]
						ox = drs[1]
						oy = drs[2]
						nox = ndrs[1]
						noy = ndrs[2]
						
						local hm = codecheck(unitid,ox,oy)
						local hm2 = codecheck(unitid,nox,noy)
						
						if (#hm == 0) and (#hm2 > 0) then
							table.insert(firstwords, {unitid, i})
							
							alreadyused[tileid] = 1
						end
					end
				end
			end
			
			docode(firstwords)
			postrules()
			grouprules()
			updatecode = 0
		end
	end
end

function docode(firstwords)
	if (#firstwords > 0) then
		for k,unitdata in ipairs(firstwords) do
			local unit = mmf.newObject(unitdata[1])
			local x,y = unit.values[XPOS],unit.values[YPOS]
			local ox,oy = 0,0
			local name = unit.strings[NAME]
			
			local dir = unitdata[2]
			local drs = dirs[dir]
			ox = drs[1]
			oy = drs[2]
			
			local variations = 1
			local done = false
			local sentences = {}
			local variantcount = {}
			local combo = {}
			
			local finals = {}
			
			local steps = 0
			
			while (done == false) do
				local words = codecheck(unitdata[1],ox*steps,oy*steps)
				steps = steps + 1
				
				sentences[steps] = {}
				local sent = sentences[steps]
				
				table.insert(variantcount, #words)
				table.insert(combo, 1)
				
				if (#words > 0) then
					variations = variations * #words
					
					if (variations > #finals) then
						local limitdiff = variations - #finals
						for i=1,limitdiff do
							table.insert(finals, {})
						end
					end
					
					for i,v in ipairs(words) do
						local tile = mmf.newObject(v)
						local tilename = tile.strings[NAME]
						local tiletype = tile.values[TYPE]
						table.insert(sent, {tilename, tiletype, v})
					end
				else
					done = true
				end
			end
			
			if (#sentences > 2) then
				for i=1,variations do
					local limit = 0
					local current = finals[i]
					local prevnot = false
					done = false
					
					for j=1,#variantcount do
						if (done == false) then
							if (variantcount[j] > 0) then
								local sent = sentences[j]
								local choice = combo[j]
								local s = sent[choice]
								
								local tiletype = s[2]
								
								if (tiletype ~= 3) and (tiletype ~= 4) then
									if (tiletype == 1) then
										limit = limit - 1
									else
										limit = limit + 1
									end
								elseif (tiletype == 3) then
									if (j > 1) and (prevnot == false) then
										limit = -1
									end
								end
								
								if (limit >= 0) and (limit <= 1) then
									table.insert(current, {s[1], s[2], s[3]})
								else
									if (j > 1) then
										table.insert(firstwords, {s[3], unitdata[2]})
									end
									
									if (tiletype == 1) and (j == 1) then
										limit = 0
									else
										done = true
									end
								end
								
								if (tiletype == 4) then
									prevnot = true
								else
									prevnot = false
								end
							else
								local latest = current[#current]
								
								if (latest[2] == 1) or (latest[2] == 3) or (latest[2] == 4) then
									table.remove(current, #current)
								end
								
								done = true
							end
						end
					end
					
					combo = updatecombo(combo,variantcount)
				end
			end
			
			if (#finals > 0) then
				for i,sentence in ipairs(finals) do
					local phase = 0
					local absphase = 0
					limit = 0
					local groups = {}
					local ops = {}
					local groupid = 1
					groups[groupid] = {}
					local extra = ""
					local extraids = {}
					local prevnot = false
					
					for a,b in ipairs(sentence) do
						if (b[2] ~= 1) and (b[2] ~= 3) and (b[2] ~= 4) then
							local thisgroup = groups[groupid]
							table.insert(thisgroup, {extra .. b[1], b[2], b[3]})
							limit = limit + 1
						end
						
						if (b[2] == 1) then
							if (b[1] ~= "and") then
								table.insert(ops, {extra .. b[1], b[2], b[3]})
								
								groupid = groupid + 1
								groups[groupid] = {}
							else
								table.insert(extraids, {extra .. b[1], b[2], b[3]})
							end
							limit = limit - 1
						elseif (b[2] == 3) then
							if (a == 1) or prevnot then
								table.insert(ops, {extra .. b[1], b[2], b[3]})
								
								groupid = groupid + 1
								groups[groupid] = {}
							else
								limit = -1
							end
						end
						
						if (b[2] == 4) then
							if (extra == "not ") then
								extra = ""
							else
								extra = "not "
							end
							table.insert(extraids, {b[1], b[2], b[3]})
						else
							extra = ""
						end
						
						local operators = {"is","has","on","make","follow","eat","near","alone"}
						
						for c,d in ipairs(operators) do
							if (b[1] == d) and (phase ~= c) then
								phase = c
								absphase = absphase + 1
							end
						end
						
						if (absphase > 3) then
							local previous = sentence[a-1]
							table.insert(firstwords, {previous[3], dir})
							table.remove(ops, #ops)
							table.insert(ops, {"end", 3, 0})
							break
						end
						
						if (limit < 0) or (limit > 1) then
							phase = 99
							limit = 99
							
							if (limit < 0) then
								table.remove(ops, #ops)
							elseif (limit > 1) then
								local thisgroup = groups[groupid]
								table.remove(thisgroup, #thisgroup)
								
								if (#thisgroup == 0) then
									table.remove(groups, groupid)
								end
							end
							
							table.insert(ops, {"end", 3, 0})
							break
						end
						
						if (b[2] == 4) then
							prevnot = true
						else
							prevnot = false
						end
					end
					
					if (#groups > 0) then
						for a,group in ipairs(groups) do
							local style = {}
							local prevstyle = {}
							local nextstyle = {}
							
							local nextgroup = groups[a+1]
							local nextgroup2 = groups[a+2]
							local prevgroup = groups[a-1]
							
							local word,prevword,nextword = "","",""
							
							if (ops[a] ~= nil) then
								style = ops[a]
								word = style[1]
							else
								--TEE TÄLLE JOTAIN
								--print("no operator for group " .. tostring(a) .. "/" .. tostring(#groups))
							end
							
							if (ops[a-1] ~= nil) then
								prevstyle = ops[a-1]
								prevword = prevstyle[1]
							end
							
							if (ops[a+1] ~= nil) then
								nextstyle = ops[a+1]
								nextword = nextstyle[1]
							end
							
							if (word ~= "") then
								local group1 = nil
								local group2 = nil
								local thisstyle = nil
								local condgroup = {}
								local condword = {}
								
								local isitcond,condtype = iscond(word)
								
								if isitcond then
									if (condtype == 0) then
										if (nextgroup ~= nil) and (nextgroup2 ~= nil) and (#nextstyle > 0) then
											group1 = group
											group2 = nextgroup2
											thisstyle = nextstyle
											table.insert(condgroup, nextgroup)
											table.insert(condword, word)
										end
										
										if (nextgroup ~= nil) and (prevgroup ~= nil) and (#prevstyle > 0) then
											group1 = prevgroup
											group2 = group
											thisstyle = prevstyle
											table.insert(condgroup, nextgroup)
											table.insert(condword, word)
										end
									elseif (condtype == 1) then
										group1 = nextgroup
										group2 = nextgroup2
										thisstyle = nextstyle
										table.insert(condgroup, {})
										table.insert(condword, word)
									end
								elseif (iscond(word) == false) and (iscond(prevword) == false) and (iscond(nextword) == false) then
									group1 = group
									group2 = nextgroup
									thisstyle = style
								end
								
								local delcond = {}
								
								if (#condgroup > 0) and (condtype == 0) then
									local condgrouplimit = #condgroup
									for c,d in ipairs(condgroup) do
										local thiscond = condword[c]
										local needconds = false
										
										for m,n in ipairs(conditions) do
											if iscond(n) then
												needconds = true
											end
										end
										
										if needconds then
											if (c <= condgrouplimit) then
												local needanti = false
												local anticonds = {}
												local condcopy = {}
												
												if (#d > 0) then
													for m,n in ipairs(d) do
														table.insert(condcopy, n[1])
													end
													
													local currid = 1
													
													for e,f in ipairs(condcopy) do
														local currcond = d[currid]
														
														local notcond = string.sub(currcond[1], 1, 3)
														
														if (notcond == "not") then
															needanti = true
															local newfname = string.sub(currcond[1], 5)
															local newf = {newfname, currcond[2], currcond[3]}
															table.insert(anticonds, newf)
															table.remove(d, currid)
															currid = currid - 1
														end
														
														currid = currid + 1
													end
												end
												
												if needanti then
													local thiscondname = condword[c]
													local condnot = string.sub(thiscondname, 1, 3)
													local newcondname = ""
													
													if (condnot ~= "not") then
														newcondname = "not " .. thiscondname
													else
														newcondname = string.sub(thiscondname, 5)
													end
													
													table.insert(condword, newcondname)
													table.insert(condgroup, anticonds)
												end
											end
											
											if (#d == 0) then
												table.insert(delcond, c)
											end
										end
									end
								end
								
								if (#delcond > 0) then
									local offset = 0
									for m,n in ipairs(delcond) do
										table.remove(condgroup, n - offset)
										table.remove(condword, n - offset)
										offset = offset + 1
									end
								end
								
								table.insert(extraids, style)
								
								if (group1 ~= nil) and (thisstyle ~= nil) then
									for c,target in ipairs(group1) do
										if (group2 ~= nil) then
											for e,object in ipairs(group2) do
												local rule = {target[1],thisstyle[1],object[1]}
												local ids = {target[3],thisstyle[3],object[3]}
												local conds = {}
												
												if (#extraids > 0) then
													for g,h in ipairs(extraids) do
														table.insert(ids,h[3])
													end
												end
												
												if (#condword > 0) then
													for m,n in ipairs(condword) do
														local thiscondname = n
														local thiscondgroup = condgroup[m]
														local condnames = {}
														
														if (#thiscondgroup > 0) then
															for o,p in ipairs(thiscondgroup) do
																table.insert(condnames, p[1])
																table.insert(ids, p[3])
															end
														end
														
														table.insert(conds, {thiscondname, condnames})
													end
												end
												
												addoption(rule,conds,ids)
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

function codecheck(unitid,ox,oy)
	local unit = mmf.newObject(unitid)
	local x,y = unit.values[XPOS]+ox,unit.values[YPOS]+oy
	local result = {}
	
	local tileid = x + y * roomsize
	
	if (unitmap[tileid] ~= nil) then
		for i,b in ipairs(unitmap[tileid]) do
			local v = mmf.newObject(b)
			
			if (v.strings[UNITTYPE] == "text") then
				table.insert(result, b)
			end
		end
	end
	
	return result
end

function addoption(option,conds_,ids,visible)
	local visual = true
	
	if (visible ~= nil) then
		visual = visible
	end
	
	local conds = {}
	
	if (conds_ ~= nil) then
		conds = conds_
	else
		print("nil conditions in rule: " .. option[1] .. ", " .. option[2] .. ", " .. option[3])
	end
	
	if (#option == 3) then
		local rule = {option,conds,ids}
		table.insert(features, rule)
		local target = option[1]
		local effect = option[3]
		local verb = option[2]
	
		if (featureindex[effect] == nil) then
			featureindex[effect] = {}
		end
		
		if (featureindex[target] == nil) then
			featureindex[target] = {}
		end
		
		if (featureindex[verb] == nil) then
			featureindex[verb] = {}
		end
		
		table.insert(featureindex[effect], rule)
		
		table.insert(featureindex[verb], rule)
		
		if (target ~= effect) then
			table.insert(featureindex[target], rule)
		end
		
		if visual then
			local visualrule = copyrule(rule)
			table.insert(visualfeatures, visualrule)
		end
		
		if (#conds > 0) then
			for i,cond in ipairs(conds) do
				if (cond[2] ~= nil) then
					if (#cond[2] > 0) then
						local alreadyused = {}
						local delnames = {}
						local allfound = false
						
						alreadyused[target] = 1
						
						for a,b in ipairs(cond[2]) do
							if (b ~= "all") then
								alreadyused[b] = 1
							else
								allfound = true
								table.insert(delnames, a)
							end
						end
						
						if allfound then
							for a,mat in pairs(objectlist) do
								if (alreadyused[a] == nil) then
									table.insert(cond[2], a)
									alreadyused[a] = 1
								end
							end
						end
						
						if (#delnames > 0) then
							local deloffset = 0
							for a,b in ipairs(delnames) do
								table.remove(cond[2], b-deloffset)
								deloffset = deloffset + 1 
							end
						end
					end
				end
			end
		end

		local targetnot = string.sub(target, 1, 3)
		local targetnot_ = string.sub(target, 5)
		
		if (targetnot == "not") then
			for i,mat in pairs(objectlist) do
				if (i ~= "empty") and (i ~= "all") and (i ~= "level") and (i ~= "group") and (i ~= targetnot_) then
					local rule = {i,verb,effect}
					--print(i .. " " .. verb .. " " .. effect)
					local ids = {}
					local newconds = {}
					for a,b in ipairs(conds) do
						table.insert(newconds, b)
					end
					addoption(rule,newconds,ids,false)
				end
			end
		end
		
		if (effect == "all") then
			if (verb ~= "is") then 
				for i,mat in pairs(objectlist) do
					if (i ~= "empty") and (i ~= "all") and (i ~= "level") and (i ~= "group") then
						local rule = {target,verb,i}
						local ids = {}
						local newconds = {}
						for a,b in ipairs(conds) do
							table.insert(newconds, b)
						end
						addoption(rule,newconds,ids,false)
					end
				end
			end
		end

		if (target == "all") then
			for i,mat in pairs(objectlist) do
				if (i ~= "empty") and (i ~= "all") and (i ~= "level") and (i ~= "group") then
					local rule = {i,verb,effect}
					local ids = {}
					local newconds = {}
					for a,b in ipairs(conds) do
						table.insert(newconds, b)
					end
					addoption(rule,newconds,ids,false)
				end
			end
		end
	end
end

function postrules()
	local notfeatures = {}
	local limit = #features
	local newruleids = {}
	local playrulesound = false
	
	local protects = {}
	
	for i,rules in ipairs(features) do
		if (i <= limit) then
			local rule = rules[1]
			local conds = rules[2]
			local ids = rules[3]
			
			if (rule[1] == rule[3]) and (rule[2] == "is") then
				table.insert(protects, i)
			end
			
			if (ids ~= nil) then
				local works = true
				local idlist = {}
				local effectsok = false
				
				if (#ids > 0) then
					for a,b in ipairs(ids) do
						table.insert(idlist, b)
						local bunit = mmf.newObject(b)
						local btype = bunit.values[TYPE]
						
						if (btype == 1) and (bunit.strings[UNITNAME] == "text_is") then
							effectsok = true
						elseif (btype == 1) and (bunit.strings[UNITNAME] ~= "text_is") and (bunit.strings[UNITNAME] ~= "text_and") then
							effectsok = false
						end
						
						if (btype == 2) and (effectsok == false) then
							works = false
						end
					end
				end
				
				if (#idlist > 0) and works then
					for a,b in ipairs(idlist) do
						setcolour(b,"active")
						newruleids[b] = 1
						
						if (ruleids[b] == nil) and (#undobuffer > 1) then
							local bunit = mmf.newObject(b)
							local x,y = bunit.values[XPOS],bunit.values[YPOS]
							local c1,c2 = getcolour(b,"active")
							MF_particles("bling",x,y,5,c1,c2)
							playrulesound = true
						end
					end
				end
			end

			local rulenot = 0
			local neweffect = ""
			
			local nothere = string.sub(rule[3], 1, 3)
			
			if (nothere == "not") then
				rulenot = 1
				neweffect = string.sub(rule[3], 5)
			end
			
			if (rulenot == 1) then
				local newconds = {}
				
				if (#conds > 0) then
					for a,cond in ipairs(conds) do
						local newcond = cond
						local condname = cond[1]
						local params = cond[2]
						
						local prefix = string.sub(condname, 1, 3)
						
						if (prefix == "not") then
							condname = string.sub(condname, 5)
						else
							condname = "not " .. condname
						end
						
						newcond[1] = condname
						newcond[2] = {}
						
						if (#params > 0) then
							for m,n in ipairs(params) do
								table.insert(newcond[2], n)
							end
						end
						
						table.insert(newconds, newcond)
					end
				else
					table.insert(newconds, {"never"})
				end
				
				local newbaserule = {rule[1],rule[2],neweffect}
				
				local target = rule[1]
				local verb = rule[2]
				
				for a,b in ipairs(featureindex[target]) do
					local same = comparerules(newbaserule,b[1])
					
					if same then
						local theseconds = b[2]
						
						if (#newconds > 0) then
							if (newconds[1] ~= "never") then
								for c,d in ipairs(newconds) do
									table.insert(theseconds, d)
								end
							else
								theseconds = {"never"}
							end
						end
						
						b[2] = theseconds
					end
				end
			end
		end
	end
	
	if (#protects > 0) then
		for i,v in ipairs(protects) do
			local rule = features[v]
			
			local baserule = rule[1]
			local conds = rule[2]
			
			local target = baserule[1]
			
			local newconds = {{"never"}}
			
			if (conds[1] ~= "never") then
				if (#conds > 0) then
					newconds = {}
					
					for a,b in ipairs(conds) do
						local condword = b[1]
						local condgroup = {}
						
						local newcondword = "not " .. condword
						
						if (string.sub(condword, 1, 3) == "not") then
							newcondword = string.sub(condword, 5)
						end
						
						if (b[2] ~= nil) then
							for c,d in ipairs(b[2]) do
								table.insert(condgroup, d)
							end
						end
						
						table.insert(newconds, {newcondword, condgroup})
					end
				end		
			
				if (featureindex[target] ~= nil) then
					for a,rules in ipairs(featureindex[target]) do
						local targetrule = rules[1]
						local targetconds = rules[2]
						
						local object = targetrule[3]
						
						if (targetrule[1] == target) and (targetrule[2] == "is") and (target ~= object) and (getmat(object) ~= nil) then
							if (#newconds > 0) then
								if (newconds[1] == "never") then
									targetconds = {}
								end
								
								for c,d in ipairs(newconds) do
									table.insert(targetconds, d)
								end
							end
							
							rules[2] = targetconds
						end
					end
				end
			end
		end
	end
	
	ruleids = newruleids
	
	local rulename = "rule" .. tostring(math.random(1,5))
	
	if playrulesound then
		MF_playsound(rulename,100)
	end
end

function iscond(word)
	for i,v in ipairs(conditions) do
		if (word == v) or (word == "not " .. v) then
			return true,0
		end
	end
	
	for i,v in ipairs(simpleconds) do
		if (word == v) or (word == "not " .. v) then
			return true,1
		end
	end
	
	return false,0
end

function grouprules()
	local isgroup = {}
	local groupis = {}
	local groups = findgroup()
	
	if (featureindex["group"] ~= nil) then
		for i,rule in ipairs(featureindex["group"]) do
			local baserule = rule[1]
			local conds = rule[2]
			
			if (baserule[1] == "group") then
				table.insert(groupis, rule)
			end

			if (baserule[3] == "group") and (baserule[1] ~= "group") then
				table.insert(isgroup, rule)
			end
		end
	end
	
	local ends = {}
	local starts = {}
	
	if (#groupis > 0) then
		for i,rule in ipairs(groupis) do
			local baserule = rule[1]
			local conds = rule[2]
			local verb = baserule[2]
			local effect = baserule[3]
			
			table.insert(ends, {effect,verb,conds})
		end
	end			
	
	if (#isgroup > 0) then
		for i,rule in ipairs(isgroup) do
			local baserule = rule[1]
			local conds = rule[2]
			local verb = baserule[2]
			local target = baserule[1]
			
			table.insert(starts, {target,verb,conds})
		end
	end
	
	local ids = {}
	
	for i,v in ipairs(starts) do
		if (v[2] ~= "is") then
			local conds = {}
			if (#v[3] > 0) then
				for a,b in ipairs(v[3]) do
					table.insert(conds, b)
				end
			end
			
			for a,b in ipairs(starts) do
				if (b[2] == "is") then
					if (#b[3] > 0) then
						for c,d in ipairs(b[3]) do
							table.insert(conds, d)
						end
					end
					
					addoption({v[1],v[2],b[1]},conds,ids,false)
				end
			end
		end
		
		for a,b in ipairs(ends) do
			local conds = {}
			
			if (#v[3] > 0) then
				for c,d in ipairs(v[3]) do
					table.insert(conds, d)
				end
			end
			
			if (#b[3] > 0) then
				for c,d in ipairs(b[3]) do
					table.insert(conds, d)
				end
			end
			
			if (v[2] == "is") then
				addoption({v[1],b[2],b[1]},conds,ids,false)
			end
		end
	end
	
	if (#features > 0) and (#groups > 0) then
		for i,rules in ipairs(features) do
			local rule = rules[1]
			local conds = rules[2]
			
			if (#conds > 0) then
				for m,n in ipairs(conds) do
					if (n[2] ~= nil) then
						if (#n[2] > 0) then
							local thisrule = n[2]
							local limit = #n[2]
							local delthese = {}

							for a=1,limit do
								local b = thisrule[a]
								
								if (b == "group") then
									if (#groups > 0) then
										for c,d in ipairs(groups) do
											if (d[1] ~= "group") then
												table.insert(n[2], d[1])
												
												if (d[2] ~= nil) then
													for e,f in ipairs(d[2]) do
														if (f ~= "group") then
															table.insert(n[2], f)
														end
													end
												end
											end
										end
									end
									
									table.insert(delthese, a)
								end
							end
							
							if (#delthese > 0) then
								local offset = 0
								for a,b in ipairs(delthese) do
									local id = b + offset
									table.remove(n[2], id)
									offset = offset - 1
								end
							end
						end
					end
				end
			end
		end
	end					
end

function copyrule(rule)
	local baserule = rule[1]
	local conds = rule[2]
	local ids = rule[3]
	
	local newbaserule = {}
	local newconds = {}
	local newids = {}
	
	newbaserule = {baserule[1],baserule[2],baserule[3]}
	
	if (#conds > 0) then
		for i,cond in ipairs(conds) do
			local newcond = {cond[1]}
			
			if (cond[2] ~= nil) then
				local condnames = cond[2]
				newcond[2] = {}
				
				for a,b in ipairs(condnames) do
					table.insert(newcond[2], b)
				end
			end
			
			table.insert(newconds, newcond)
		end
	end
	
	if (#ids > 0) then
		for i,id in ipairs(ids) do
			table.insert(newids, id)
		end
	end
	
	local newrule = {newbaserule,newconds,newids}
	
	return newrule
end

function updatecombo(combo_,variants)
	local increment = 1
	local combo = {}
	
	for i,v in ipairs(variants) do
		combo[i] = combo_[i]
		if (v > 1) then
			combo[i] = combo[i] + increment
			increment = 0
			
			if (combo[i] > v) then
				combo[i] = 1
				increment = 1
			end
		elseif (v == 0) then
			--print("no variants here?")
		end
	end
	
	if (increment == 0) then
		return combo
	else
		return nil
	end
end